package org.opensi.compta;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.List;

import org.experlog.openeas.api.Session;
import org.opensi.util.tools.DateTime;



public class CollectionEcritures {
	private String base;
	private String basedossier;
	private Session session;
	private long periode_int=0;
	private int nbreLigneRappro=0;
	private String action;// c=copie, t=transfert,s=suppression 
	
public CollectionEcritures(String Base, Session s, String basedossier, String action){
	this.base=Base;
	this.session=s;
	this.basedossier=basedossier;
	this.action=action;
}
	
public void setPeriode_interv(long periode) {

	this.periode_int = periode;
}	
public long getPeriode_inter() {

	return periode_int;
}	
	 // retourne une liste de numro d'ecriture pour un journal donn  une priode donne
	public List getEcritures(String codeJournal, long dateEcriture) {

		List<Integer> resultat = new ArrayList<Integer>();
		
	
		try {
			Connection con = session.getConnection(null);
			String requeteSql="";
			String reqnbLR="";
				if ( periode_int==0){
					if(action.equals("c")){
						requeteSql = "select Num_Ecriture from "+ base +".ECRITURE e ";
						requeteSql += "where Date_Ecriture="+ dateEcriture + " and Code_Journal='"+codeJournal+"' and vide=0";
					}
					else{
						requeteSql = "select distinct e.Num_Ecriture from  "+ base +".ECRITURE e ";
						requeteSql += "where Date_Ecriture="+ dateEcriture + " and Code_Journal='"+codeJournal+"' and vide=0 ";
						requeteSql += "and e.Num_Ecriture Not In  (select o.Num_Ecriture from "+ base +".OPERATION o, "+ basedossier +".LIGNE_RAPPROCHEMENT lp  where o.Op_Id=lp.Op_Id and lp.Nom_Base='"+ base +"') ";
						requeteSql += "order by Date_Ecriture";
						reqnbLR = "select count(distinct e.Num_Ecriture) from  "+ base +".ECRITURE e ";
						reqnbLR += "where Date_Ecriture="+ dateEcriture + " and Code_Journal='"+codeJournal+"' and vide=0 ";
						reqnbLR += "and e.Num_Ecriture  In  (select o.Num_Ecriture from "+ base +".OPERATION o, "+ basedossier +".LIGNE_RAPPROCHEMENT lp  where o.Op_Id=lp.Op_Id and lp.Nom_Base='"+ base +"') ";
//						nombre d'critures dont des oprations se trouvent dans la table LIGNE_RAPPROCHEMENT
				      	Statement stt2 = con.createStatement();
					    ResultSet rset2 = stt2.executeQuery(reqnbLR);

				      	while (rset2.next()) {

					        nbreLigneRappro = rset2.getInt(1);			       
				      	}
					}
				
				}
			      else {
			    	if(action.equals("c")){
				    	requeteSql = "select Num_Ecriture from "+ base +".ECRITURE e ";
						requeteSql += "where Date_Ecriture BETWEEN "+ dateEcriture + " and " +periode_int+ " and Code_Journal='"+codeJournal+"' and vide=0  order by Date_Ecriture";
			    	} 
			    	else{
			    	  //reqnbLR="select count(distinct e.Num_Ecriture) from  "+ base +".ECRITURE e join  "+ base +".OPERATION o on o.Num_Ecriture=e.Num_Ecriture  left join  "+ basedossier +".LIGNE_RAPPROCHEMENT lp on o.Op_Id=lp.Op_Id where lp.Nom_Base='"+ base +"' and Date_Ecriture BETWEEN "+ dateEcriture + " and " +periode_int+ " and Code_Journal='"+codeJournal+"' and vide=0  order by Date_Ecriture";
						requeteSql = "select distinct e.Num_Ecriture from  "+ base +".ECRITURE e ";
						requeteSql += "where Date_Ecriture BETWEEN "+ dateEcriture + " and " +periode_int+ " and Code_Journal='"+codeJournal+"' and vide=0 ";
						requeteSql += "and e.Num_Ecriture Not In  (select o.Num_Ecriture from "+ base +".OPERATION o, "+ basedossier +".LIGNE_RAPPROCHEMENT lp  where o.Op_Id=lp.Op_Id and lp.Nom_Base='"+ base +"') ";
						requeteSql += "order by Date_Ecriture";
						reqnbLR = "select count(distinct e.Num_Ecriture) from  "+ base +".ECRITURE e ";
						reqnbLR += "where Date_Ecriture BETWEEN "+ dateEcriture + " and " +periode_int+ " and Code_Journal='"+codeJournal+"' and vide=0 ";
						reqnbLR += "and e.Num_Ecriture  In  (select o.Num_Ecriture from "+ base +".OPERATION o, "+ basedossier +".LIGNE_RAPPROCHEMENT lp  where o.Op_Id=lp.Op_Id and lp.Nom_Base='"+ base +"') ";
//						nombre d'critures dont des oprations se trouvent dans la table LIGNE_RAPPROCHEMENT
				      	Statement stt2 = con.createStatement();
					    ResultSet rset2 = stt2.executeQuery(reqnbLR);

				      	while (rset2.next()) {

					        nbreLigneRappro = rset2.getInt(1);			       
				      	}
			    	
			    	}
					
			      
			      }
				 System.out.println(" requeteSql"+ requeteSql);
				 System.out.println(" reqnbLR"+ reqnbLR);
				
			    Statement stt = con.createStatement();
			    ResultSet rset = stt.executeQuery(requeteSql);

		      	while (rset.next()) {

			        int numecr = rset.getInt("Num_Ecriture");
			        resultat.add(new Integer(numecr));
		      	}
		      	
		      	
		      	
		      	session.closeConnection(con, null);
			}
			catch (Exception e) {
				e.printStackTrace();
			}
			return resultat;
		}

// retourne une liste de numro d'ecriture pour un journal donn  une priode donne
public List getEcritures(String codeJournal, long dateEcriture, int numDebut, int numFin) {

	
	
	List<Integer> resultat = new ArrayList<Integer>();
	

	try {
		 Connection con = session.getConnection(null);
		String requeteSql="";
		String reqnbLR="";
		if ( periode_int==0){
			if(action.equals("c")){
				requeteSql = "select Num_Ecriture from "+ base +".ECRITURE e ";
				requeteSql += "where Date_Ecriture="+ dateEcriture + " and vide=0 and Code_Journal='"+codeJournal+"' and Numero BETWEEN "+numDebut+" and "+numFin;
			}
			else{
			  	requeteSql = "select Num_Ecriture from "+ base +".ECRITURE e ";
			  	requeteSql += "where Date_Ecriture="+ dateEcriture + " and vide=0 and Code_Journal='"+codeJournal+"' and Numero BETWEEN "+numDebut+" and "+numFin;
				requeteSql += " and e.Num_Ecriture Not In  (select o.Num_Ecriture from "+ base +".OPERATION o, "+ basedossier +".LIGNE_RAPPROCHEMENT lp  where o.Op_Id=lp.Op_Id and lp.Nom_Base='"+ base +"') ";
				requeteSql += "order by Date_Ecriture";
				reqnbLR = "select count(distinct e.Num_Ecriture) from  "+ base +".ECRITURE e ";
				reqnbLR += "where Date_Ecriture="+ dateEcriture + " and vide=0 and Code_Journal='"+codeJournal+"' and Numero BETWEEN "+numDebut+" and "+numFin;
				reqnbLR += " and e.Num_Ecriture  In  (select o.Num_Ecriture from "+ base +".OPERATION o, "+ basedossier +".LIGNE_RAPPROCHEMENT lp  where o.Op_Id=lp.Op_Id and lp.Nom_Base='"+ base +"') ";
//			      nombre d'critures dont des oprations se trouvent dans la table LIGNE_RAPPROCHEMENT
		      	Statement stt2 = con.createStatement();
			    ResultSet rset2 = stt2.executeQuery(reqnbLR);

		      	while (rset2.next()) {

			        nbreLigneRappro = rset2.getInt(1);			       
		      	}
			}
		
		}
	      else {
	    	if(action.equals("c")){  
		    	requeteSql = "select Num_Ecriture from "+ base +".ECRITURE e ";
				requeteSql += "where Date_Ecriture BETWEEN "+ dateEcriture + " and " +periode_int+ " and Code_Journal='"+codeJournal+"' and vide=0 and Numero BETWEEN "+numDebut+" and "+numFin+" order by Date_Ecriture"; 
	    	 }
			else{
				requeteSql = "select Num_Ecriture from "+ base +".ECRITURE e ";
			  	requeteSql += "where Date_Ecriture BETWEEN "+ dateEcriture + " and " +periode_int+ " and Code_Journal='"+codeJournal+"' and vide=0 and Numero BETWEEN "+numDebut+" and "+numFin;
				requeteSql += " and e.Num_Ecriture Not In  (select o.Num_Ecriture from "+ base +".OPERATION o, "+ basedossier +".LIGNE_RAPPROCHEMENT lp  where o.Op_Id=lp.Op_Id and lp.Nom_Base='"+ base +"') ";
				requeteSql += "order by Date_Ecriture";
				reqnbLR = "select count(distinct e.Num_Ecriture) from  "+ base +".ECRITURE e ";
				reqnbLR += "where Date_Ecriture BETWEEN "+ dateEcriture + " and " +periode_int+ " and Code_Journal='"+codeJournal+"' and vide=0 and Numero BETWEEN "+numDebut+" and "+numFin;
				reqnbLR += " and e.Num_Ecriture  In  (select o.Num_Ecriture from "+ base +".OPERATION o, "+ basedossier +".LIGNE_RAPPROCHEMENT lp  where o.Op_Id=lp.Op_Id and lp.Nom_Base='"+ base +"') ";
//			      nombre d'critures dont des oprations se trouvent dans la table LIGNE_RAPPROCHEMENT
		      	Statement stt2 = con.createStatement();
			    ResultSet rset2 = stt2.executeQuery(reqnbLR);

		      	while (rset2.next()) {

			        nbreLigneRappro = rset2.getInt(1);			       
		      	}
			}
	      
	      }
		  
		 System.out.println(" requeteSql"+ requeteSql);
		 System.out.println(" reqnbLR"+ reqnbLR);
	     
	      Statement stt = con.createStatement();
	      ResultSet rset = stt.executeQuery(requeteSql);

	      	while (rset.next()) {

		        int numecr = rset.getInt("Num_Ecriture");
		        resultat.add(new Integer(numecr));
		       
		       
	      	}

		session.closeConnection(con, null);

		} catch (Exception e) {
			e.printStackTrace();
		}
		return resultat;
	}

// retourne une liste de numro d'ecriture pour un journal donn pour des dates d'operations donnes 
public List getEcrituresOp(String codeJournal, long dateEcriture, long datedeb, long datefin) {

	List<Integer> resultat = new ArrayList<Integer>();
	DateTime dt0= new DateTime(dateEcriture);
	long dtecriture=dt0.getDateInMillis();
			
	try {
		Connection con = session.getConnection(null);

		
		String requeteSql="";
		String reqnbLR="";
		if ( periode_int==0){
			
			
			DateTime dt1= new DateTime(dtecriture);	    	 	
		 	if (datedeb<dt1.currentMaxDay()){
		 		dt1.setDay((int) datedeb);
			}
			else{
				dt1.currentMaxDay();
			}
			
			long dtdebut=dt1.getDateInMillis();
			DateTime dt2= new DateTime(dtecriture);
			if (datefin<dt2.currentMaxDay()){
				dt2.setDay((int) datefin);
			
			}
			else{
				dt2.currentMaxDay();
			}
			
			long dtfin=dt2.getDateInMillis();
			
			if(action.equals("c")){
				requeteSql = "select distinct e.Num_Ecriture from "+ base +".ECRITURE e,"+ base +".OPERATION o ";
				requeteSql += "where e.Num_Ecriture=o.Num_Ecriture and Date_Ecriture="+ dateEcriture + " and vide=0 and Code_Journal='"+codeJournal+"' and o.Date_OP>="+dtdebut+"  and o.Date_OP <="+dtfin+ " order by Date_Ecriture";
			}
			else{
				
			
			requeteSql = "select distinct e.Num_Ecriture from "+ base +".ECRITURE e,"+ base +".OPERATION o ";
		  	requeteSql += "where e.Num_Ecriture=o.Num_Ecriture and Date_Ecriture="+ dateEcriture + " and vide=0 and Code_Journal='"+codeJournal+"' and o.Date_OP>="+dtdebut+"  and o.Date_OP <="+dtfin;
			requeteSql += " and e.Num_Ecriture Not In  (select o.Num_Ecriture from "+ base +".OPERATION o, "+ basedossier +".LIGNE_RAPPROCHEMENT lp  where o.Op_Id=lp.Op_Id and lp.Nom_Base='"+ base +"') ";
			requeteSql += "order by Date_Ecriture";
			reqnbLR = "select count(distinct e.Num_Ecriture) from "+ base +".ECRITURE e,"+ base +".OPERATION o ";
			reqnbLR += "where e.Num_Ecriture=o.Num_Ecriture and Date_Ecriture="+ dateEcriture + " and vide=0 and Code_Journal='"+codeJournal+"' and o.Date_OP>="+dtdebut+"  and o.Date_OP <="+dtfin;
			reqnbLR += " and e.Num_Ecriture  In  (select o.Num_Ecriture from "+ base +".OPERATION o, "+ basedossier +".LIGNE_RAPPROCHEMENT lp  where o.Op_Id=lp.Op_Id and lp.Nom_Base='"+ base +"') ";
//		      nombre d'critures dont des oprations se trouvent dans la table LIGNE_RAPPROCHEMENT
	      	Statement stt2 = con.createStatement();
		    ResultSet rset2 = stt2.executeQuery(reqnbLR);

		      	while (rset2.next()) {
	
			        nbreLigneRappro = rset2.getInt(1);			       
		      	}
			}
	      Statement stt = con.createStatement();
	      ResultSet rset = stt.executeQuery(requeteSql);
	     
	      	while (rset.next()) {

		        int numecr = rset.getInt("Num_Ecriture");
		        resultat.add(new Integer(numecr));
	      	}

		}
	     else {	   
	  
	    	while (dtecriture<periode_int){
	    		
	    		dt0.setDay(1);
	    	 	dtecriture=dt0.getDateInMillis();
	    	 	
	    	 	dt0.setDay(dt0.currentMaxDay());
	    	 	long dtecrituremax=dt0.getDateInMillis();
	    	 
		    	 	DateTime dt1= new DateTime(dtecriture);	    	 	
		    	 	if (datedeb<dt1.currentMaxDay()){
		    	 		dt1.setDay((int) datedeb);
		    		}
		    		else{
		    			dt1.currentMaxDay();
		    		}
		    		
		    		long dtdebut=dt1.getDateInMillis();
		    	
		    		DateTime dt2= new DateTime(dtecriture);
		    		if (datefin<dt2.currentMaxDay()){
		    			dt2.setDay((int) datefin);
		    		}
		    		else{
		    			dt2.currentMaxDay();
		    		}
		    			    		
		    		long dtfin=dt2.getDateInMillis();
		    	if(action.equals("c")){
		    		requeteSql = "select distinct e.Num_Ecriture from "+ base +".ECRITURE e,"+ base +".OPERATION o ";
		    		requeteSql += "where e.Num_Ecriture=o.Num_Ecriture and Date_Ecriture BETWEEN "+ dtecriture + " and " +dtecrituremax+ " and Code_Journal='"+codeJournal+"' and vide=0 and o.Date_OP >="+dtdebut+"  and o.Date_OP<="+dtfin+" order by Date_Ecriture"; 
		    	}
		    	else{
					requeteSql = "select distinct e.Num_Ecriture from "+ base +".ECRITURE e,"+ base +".OPERATION o ";
				  	requeteSql += "where e.Num_Ecriture=o.Num_Ecriture and Date_Ecriture BETWEEN "+ dtecriture + " and " +dtecrituremax+ " and Code_Journal='"+codeJournal+"' and vide=0 and o.Date_OP >="+dtdebut+"  and o.Date_OP<="+dtfin;
					requeteSql += " and e.Num_Ecriture Not In  (select o.Num_Ecriture from "+ base +".OPERATION o, "+ basedossier +".LIGNE_RAPPROCHEMENT lp  where o.Op_Id=lp.Op_Id and lp.Nom_Base='"+ base +"') ";
					requeteSql += "order by Date_Ecriture";
					reqnbLR = "select count(distinct e.Num_Ecriture) from "+ base +".ECRITURE e,"+ base +".OPERATION o ";
					reqnbLR += "where e.Num_Ecriture=o.Num_Ecriture and Date_Ecriture BETWEEN "+ dtecriture + " and " +dtecrituremax+ " and Code_Journal='"+codeJournal+"' and vide=0 and o.Date_OP >="+dtdebut+"  and o.Date_OP<="+dtfin;
					reqnbLR += " and e.Num_Ecriture  In  (select o.Num_Ecriture from "+ base +".OPERATION o, "+ basedossier +".LIGNE_RAPPROCHEMENT lp  where o.Op_Id=lp.Op_Id and lp.Nom_Base='"+ base +"') ";
//			    	nombre d'critures dont des oprations se trouvent dans la table LIGNE_RAPPROCHEMENT
			      	Statement stt2 = con.createStatement();
				    ResultSet rset2 = stt2.executeQuery(reqnbLR);

			      	while (rset2.next()) {

				        nbreLigneRappro = rset2.getInt(1);			       
			      	}
		    	
		    	}
				
				System.out.println(" requeteSql"+ requeteSql);
				 System.out.println(" reqnbLR"+ reqnbLR);
				
				
				Statement stt = con.createStatement();
			    ResultSet rset = stt.executeQuery(requeteSql);
			     
			      	while (rset.next()) {

				        int numecr = rset.getInt("Num_Ecriture");
				        resultat.add(new Integer(numecr));
			      	}
				
				
				dt0.addMonth(1);
				
	    	 }   

	     }
		 System.out.println(" requeteSql"+ requeteSql);
		 System.out.println(" reqnbLR"+ reqnbLR);
		session.closeConnection(con, null);
		} 
	catch (Exception e) {
			e.printStackTrace();
		}
		return resultat;
	}
public boolean isEcrituresLettrees(List listecriture) {
	boolean lettres=false;
	
	String List=listecriture.toString();
	List=List.replaceAll("\\[","");
	List=List.replaceAll("\\]","");	
	if (List.equals("")){
		List="''";
	}
	try {
		
		String requeteSql="";
		
		  requeteSql = "select distinct e.Num_Ecriture from "+ base +".ECRITURE e,"+ base +".OPERATION o ";
	      requeteSql += "where e.Num_Ecriture=o.Num_Ecriture and e.Num_Ecriture IN ("+List+") and Lettre <> ''  ";
		
	      Connection con = session.getConnection(null);
	      
	      Statement stt = con.createStatement();
	      ResultSet rset = stt.executeQuery(requeteSql);
	      
	      	while (rset.next()) {	      		
		       lettres=true;
	      	}
	   
		session.closeConnection(con, null);

		} catch (Exception e) {
			e.printStackTrace();
		}
		
	return lettres;
	}

public int getNbreLigneRappro() {
	return nbreLigneRappro;
}

public void setNbreLigneRappro(int nbreLigneRappro) {
	this.nbreLigneRappro = nbreLigneRappro;
}
}

