package org.opensi.compta.actions.copie;
import java.sql.*;
import java.text.SimpleDateFormat;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;

import org.experlog.openeas.api.ServletRequest;
import org.experlog.openeas.api.Action;
import org.experlog.openeas.api.Session;



import org.opensi.compta.CollectionEcritures;
import org.opensi.compta.Ecriture;
import org.opensi.compta.Operation;

import org.opensi.util.tools.DateTime;

public class SupJournaux extends Action {

		 
	
		public boolean serverSide() { return true; }

		  public boolean service(Session s, ServletRequest r, Object info) throws Exception {
			  
			  Connection con = s.getConnection(null);
	      try{
	    	    String dateCourante;
	    	    SimpleDateFormat formatDate = new SimpleDateFormat("hh'h'mm dd/MM/yyyy");
				dateCourante = formatDate.format(new Date(System.currentTimeMillis()));
	    	  //declaration des variables
	    	  int numDebut=0;
			  int numFin=0;
			  int datedebut=0;
			  int datefin=0;
			  int date1=0;
			  int date2=0;
			  int h=0;
			  Long datedeb=null;
			  Long datef=null;			  
			  List<Integer> listenumecr=null;
			  String baseini="";
			
			  String dossier=s.getCookie().get("Dossier_Id");
				String baseDossier = s.getCookie().get("BaseDossier");
			  int i=0;
			  ResultSet rset;

			  
			  Statement stt = con.createStatement();

			  String base_ini=r.getParameter("exercice_initial");
			 
		      String query_ex=new String("select Nom_Base from EXERCICE where Dossier_Id='"+dossier+"' and Num_Exercice="+base_ini);
				 //  pour chaque base cible (exercice)
				 rset=stt.executeQuery(query_ex);
				 while (rset.next()) {
				     baseini=rset.getString("Nom_Base");
			  
				 }

	    	  //recuperation des variables de critre : journal initial, journal cible, periode initiale, priode cible
		     String Journalsrc = r.getParameter("journal_initial");	
		     long periodeinitiale = DateTime.parseDate(r.getParameter("periode_initiale"), "MMyy");
		     long periodeinitiale_int = DateTime.parseDate(r.getParameter("periode_initiale_intervalle"), "MMyy");
		     int interval=new Integer(r.getParameter("interval"));
		     String choix = r.getParameter("choix");		     
		     if (choix.equals("B")){
		    	 int num1 = new Integer(r.getParameter("num1"));
			     int num2 = new Integer(r.getParameter("num2"));
		   
		//determiner le numro de dbut et de fin des critures
		     	if (num1<num2){
		     		numDebut=num1;
		     		numFin=num2;
		     		}
		     	else{
		     	    numDebut=num2;
		     	    numFin=num1;   		
		     		}
		    }
		    if (choix.equals("C")){
		    	date1 = new Integer(r.getParameter("date1"));
			    date2 = new Integer(r.getParameter("date2"));
		
		//determiner le numro de dbut et de fin des critures
		     	if (date1<date2){
		     		datedebut=date1;
		     		datefin=date2;
		     		}
		     	else{
		     		datedebut=date2;
		     	    datefin=date1;   		
		     		}
		     
		    }
		    
		     
		   //chargement de la liste des ecritures pour ces critres
		     CollectionEcritures  ecritures=new CollectionEcritures(baseini, s, baseDossier,"s");
		     if (interval>0){
		    	 ecritures.setPeriode_interv(periodeinitiale_int);
		    	 
		     }
		     if (choix.equals("A")){
		     listenumecr=ecritures.getEcritures(Journalsrc, periodeinitiale);
		     }
		     else if (choix.equals("B")){
		    	 listenumecr=ecritures.getEcritures(Journalsrc, periodeinitiale, numDebut, numFin);
		     }
		     else if (choix.equals("C")){
//		    	listenumecr=ecritures.getEcrituresOp(Journalsrc, periodeinitiale, datedeb,datef);
		    	 listenumecr=ecritures.getEcrituresOp(Journalsrc, periodeinitiale, datedebut,datefin);
		     }
		     
		     //verif si ecritures lettres
		     
		     if(ecritures.isEcrituresLettrees(listenumecr)==false){
		    	
		     
		     //pour chaque criture, load d'un objet criture
		     Iterator it=listenumecr.iterator();
	       
	        	while (it.hasNext()){
	        		Integer ecr=0;	
	        		ecr=(Integer) it.next();
	        	
	        		Ecriture loadecr=Ecriture.loadEcriture(ecr, con, baseini);
	
	        		//changement des donnes, par les donnes cibles
	      	      Hashtable operations=loadecr.getOperations();
	      	      Enumeration listeop = operations.elements();
	      	      while (listeop.hasMoreElements()) {
    				Operation op = (Operation)listeop.nextElement();
    				 int numligne= op.getNumLigne();   				 
    				 loadecr.addASupprimer(numligne);
    				 h++;
	      	      }
	      	    
	      	      loadecr.supprimer(con, baseini, baseDossier);
	      	      i++;	
	        	}
	        
	        	r.addParameter("status", "1");
	        	r.addParameter("nbreecriture", ""+i);
	        	r.addParameter("nbreoperation","" + h);
	        	r.addParameter("interval","" +interval);
	        	r.addParameter("nontransfererLR","" +ecritures.getNbreLigneRappro());
	        	System.out.println(dateCourante +" suppression du journal  : " + Journalsrc  + " periode initiale  : "+ periodeinitiale +  " interval "+ interval +" numdebut - numfin : " + numDebut +"-"+ numFin +" datedebut - datefin : " + datedebut +"-"+ datefin);
		     }
		     else{
		    	 r.addParameter("status", "ecritureslettrees");
		         r.addParameter("nbreecriture", "");
		         r.addParameter("nbreoperation","");
		         r.addParameter("interval",""); 
		     }
		 	
	      	}
	        catch (Exception e) {

				 r.addParameter("status", "fail");
				 e.printStackTrace();
				
			     }
		    finally {
				
				  s.closeConnection(con,null);
			     }
			     return true;
			  } 
			  
		  }

