package org.opensi.compta.actions.copie;
import java.sql.*;
import java.text.SimpleDateFormat;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;

import org.experlog.openeas.api.ServletRequest;
import org.experlog.openeas.api.Action;
import org.experlog.openeas.api.Session;



import org.opensi.compta.CollectionEcritures;
import org.opensi.compta.Ecriture;
//import org.opensi.compta.Ecriture2;
import org.opensi.compta.Operation;

import org.opensi.util.tools.DateTime;

public class TransfertJournaux extends Action {

		 
	
		public boolean serverSide() { return true; }

		  public boolean service(Session s, ServletRequest r, Object info) throws Exception {
			  
			  Connection con = s.getConnection(null);
	      try{
	    	    String dateCourante;
	    	    SimpleDateFormat formatDate = new SimpleDateFormat("hh'h'mm dd/MM/yyyy");
				dateCourante = formatDate.format(new Date(System.currentTimeMillis()));
	    	  //declaration des variables
	    	  int numDebut=0;
			  int numFin=0;
			  int datedebut=0;
			  int datefin=0;
			  int date1=0;
			  int date2=0;
			  Long datedeb=null;
			  Long datef=null;
			  long changeperiode = 0;
			  long periodeini=0;
			  long ecritureini=0;
			  List<Integer> listenumecr=null;
			  String baseini="";
			  String basedest="";
			  String dossier=s.getCookie().get("Dossier_Id");
				
				String baseDossier = s.getCookie().get("BaseDossier");
				
			  int i=0;
			  int j=0;
			  int h=0;
			  int g=0;
			  int f=0;
			  int nbe=0;
			  int pastransferer=0;
			  ResultSet rset;
			  ResultSet rset2;
		
			  Statement stt = con.createStatement();
			  Statement stt2 = con.createStatement();
			  String base_ini=r.getParameter("exercice_initial");
			  String base_dest=r.getParameter("exercice_cible");  
		      String query_ex=new String("select Nom_Base from EXERCICE where Dossier_Id='"+dossier+"' and Num_Exercice="+base_ini);
				 //  pour chaque base cible (exercice)
				 rset=stt.executeQuery(query_ex);
				 while (rset.next()) {
				     baseini=rset.getString("Nom_Base");
			  
				 }
				 String query_ex2=new String("select Nom_Base from EXERCICE where Dossier_Id='"+dossier+"' and Num_Exercice="+base_dest);
				 //  pour chaque base cible (exercice)
				 rset2=stt2.executeQuery(query_ex2);
				 while (rset2.next()) {
				     basedest=rset2.getString("Nom_Base");			  
				 }
				
	    	  //recuperation des variables de critre : journal initial, journal cible, periode initiale, priode cible
		     String Journalsrc = r.getParameter("journal_initial");		    
		     String journalcible = r.getParameter("journal_cible");	
		     long periodeinitiale = DateTime.parseDate(r.getParameter("periode_initiale"), "MMyy");
		     long periodecible = DateTime.parseDate(r.getParameter("periode_cible"),"MMyy" );
		  
		     long periodeinitiale_int = DateTime.parseDate(r.getParameter("periode_initiale_intervalle"), "MMyy");
		     
		     int interval=new Integer(r.getParameter("interval"));
		     String extourne = r.getParameter("extourne");		     
		     String choix = r.getParameter("choix");		     
		     if (choix.equals("B")){
		    	 int num1 = new Integer(r.getParameter("num1"));
			     int num2 = new Integer(r.getParameter("num2"));
		   
		//determiner le numro de dbut et de fin des critures
		     	if (num1<num2){
		     		numDebut=num1;
		     		numFin=num2;
		     		}
		     	else{
		     	    numDebut=num2;
		     	    numFin=num1;   		
		     		}
		    }
		    if (choix.equals("C")){
		    	date1 = new Integer(r.getParameter("date1"));
			    date2 = new Integer(r.getParameter("date2"));
		  
		//determiner le numro de dbut et de fin des critures
		     	if (date1<date2){
		     		datedebut=date1;
		     		datefin=date2;
		     		}
		     	else{
		     		datedebut=date2;
		     	    datefin=date1;   		
		     		}
		     
		    }
		    
		     
		    
		     
		   //chargement de la liste des ecritures pour ces critres
		     CollectionEcritures  ecritures=new CollectionEcritures(baseini, s,baseDossier,"t");
		     if (interval>0){
		    	 ecritures.setPeriode_interv(periodeinitiale_int);
		    	
		     }
		     if (choix.equals("A")){
		     listenumecr=ecritures.getEcritures(Journalsrc, periodeinitiale);
		     }
		     else if (choix.equals("B")){
		    	 listenumecr=ecritures.getEcritures(Journalsrc, periodeinitiale, numDebut, numFin);
		     }
		     else if (choix.equals("C")){
//		    	listenumecr=ecritures.getEcrituresOp(Journalsrc, periodeinitiale, datedeb,datef);
		    	 listenumecr=ecritures.getEcrituresOp(Journalsrc, periodeinitiale, datedebut,datefin);
		     }
		     //pour chaque criture, load d'un objet criture
		     Iterator it=listenumecr.iterator();
		     periodeini = periodeinitiale;
	        	while (it.hasNext()){
	        		Integer ecr=0;
	        		pastransferer=0;
	        		
	        		j=0;
	        		ecr=(Integer) it.next();
	        	
	        		Ecriture loadecr=Ecriture.loadEcriture(ecr, con, baseini);
	        		loadecr.setCodeJournal(journalcible);	        		
//	        		changement de periode cible dans l'intervalle
	        		if (interval>0){	
	        				
	        			DateTime dtpci = new DateTime(periodeini);
	        			DateTime dtpc = new DateTime(periodecible);
	        			ecritureini = loadecr.getDateEcriture();
        					
		        		if (periodeini==ecritureini){
		        		loadecr.setDateEcriture(periodecible);
		        		
		        		}
		        		else{	
		        			changeperiode = loadecr.getDateEcriture();		        							        				
			        		
			        		g=0;
			        			while (periodeini < ecritureini){
			        					//long test=dtpci.addMonth(1);				        					
			        				periodeini=dtpci.addMonth(g);
			        				periodecible=dtpc.addMonth(g);
			        				g++;				        					
			        			}				        								        					        			
			        				loadecr.setDateEcriture(periodecible);
			        				
		        			}
        				}
        		
	        		else{
	        			loadecr.setDateEcriture(periodecible);
	        			}
	        		
	      	 
	        		//changement des donnes, par les donnes cibles	        		
	        		//sur chaque opration, on initialise les donnes opId, lettrage, date chance, numro de piece
	        		Hashtable operations=loadecr.getOperations();
	        		
	        		Enumeration listeop = operations.elements();
		        			while (listeop.hasMoreElements()) {
		        				Operation op = (Operation)listeop.nextElement();
		        				//	si les operations sont sur le meme exercice meme lttres on recuppere les ecritures
		        				
			        				if (op.getLettre().equals("") || (base_ini.equals(base_dest))){
			        				
			        			        op.setOpId(0);
			        			        //on garde le lettrage si on est sur le meme exercice sinon on ne copie pas l'ecriture
				        				//op.setLettre("");
				        				op.setDateEcheance(0);
				        				DateTime dt0 = new DateTime(op.getDateOp());
				        				int jour=dt0.getDay();
				        				DateTime dt1 = new DateTime(periodecible);
				        			    //si le jour de l'opration est suprieur que sur la priode donn (ex transfert 31=>30)
					        				if (jour>dt1.currentMaxDay()){	        						        						
					        						dt1.setDay(dt1.currentMaxDay());	    
					        				
					        				}	        				
					        				else{
					        						dt1.setDay(jour);	
					        					}
				        					
				        				Long dateop=dt1.getDateInMillis();
				        				op.setDateOp(dateop);	        				
				        				op.setNumPiece("");
		//		        				si option extourne, on inverse le credit et le debit
				        				if(extourne.equals("Oui")){
				        					double credit=op.getMontantC();
				        					double debit=op.getMontantD();
				        					op.setMontantC(debit);
				        					op.setMontantD(credit);
				        					
				        				}
				        				
			        				}
						        	else{
						        		
						        	pastransferer=1;
						        	f++;
						        
						        	}
		        		
	        			}
		        		//si les operations sont sur le meme exercice meme lttres on transfere les ecritures
	        			if (pastransferer == 0){
	        				int Numecriture=0;
	        				Numecriture=loadecr.getNumEcriture();
	        				loadecr.setNumEcriture(0);
	        				loadecr.insertDB(con, basedest, baseDossier);
	        			
	        				Ecriture loadecr2=Ecriture.loadEcriture(ecr, con, baseini);
	        				Hashtable operations2=loadecr2.getOperations();
	        			
	        				//	et on supprime l'ecriture initiale + ses operations		
	        				Enumeration listeop2 = operations2.elements();
	        				
	    	        			while (listeop2.hasMoreElements()) {
	    	        				Operation op2 = (Operation)listeop2.nextElement();
	    	        				 int numligne= op2.getNumLigne();
	    	        				
	    		        				loadecr2.addASupprimer(numligne);
	    		        				
	    		        			h++;	
	    	        			}
	    	        		
	        				loadecr2.supprimer(con, baseini, baseDossier);
	        				
	        		
	        			
	        				i++;
	        			}
	        			//si les operations sont sur un exercice diffrent et sont lttres on ne transfere pas les ecritures concernes
	        			if (pastransferer == 1){
	        			//nombre d'ecritures non transfres
	        				nbe++;
	        			
	        			}
	        	}
	        	
	        	r.addParameter("status", "1");	        
	        	r.addParameter("nbreecriture","" + i);
	        	r.addParameter("nontransferer","" + nbe);
	        	r.addParameter("nbreoperation","" + h);
	        	r.addParameter("interval","" +interval);
	        	r.addParameter("nontransfererLR","" +ecritures.getNbreLigneRappro());
	        	
	        	System.out.println(dateCourante +" transfert du journal  : " + Journalsrc  + " vers journal " +journalcible+ " periode initiale  : "+ periodeinitiale + " periode cible  : "+ periodecible+ " interval "+ interval +" numdebut - numfin : " + numDebut +"-"+ numFin +" datedebut - datefin : " + datedebut +"-"+ datefin);
	      	}
	        catch (Exception e) {
	        	

				 r.addParameter("status", "fail");
				 e.printStackTrace();
				
			     }
		    finally {
				
			   
				  s.closeConnection(con,null);
			     }
			     return true;
			  } 
			  
		  }

