/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/
  
/**
 *  Sauvegarde des rponses du questionnaire
 */

package org.opensi.compta.actions.suiviActivite;

import java.io.*;
import java.sql.*;
import org.experlog.openeas.api.ServletRequest;
import org.experlog.openeas.api.Action;
import org.experlog.openeas.api.Session;


public class sauveQuestionnaire extends Action {


	public boolean serverSide() { return true; }

  public boolean service(Session s, ServletRequest r, Object info) throws Exception {

		Connection con = s.getConnection(null);
		
		String baseDossier = s.getCookie().get("BaseDossier");

		String inventaire = r.getParameter("I");
		String coeff_sais = r.getParameter("C");
		String domaine = r.getParameter("D");
		String MC = r.getParameter("mc");
		String MBP = r.getParameter("mbp");
		String listeSaison = r.getParameter("L");

		String requeteDel = "delete from "+ baseDossier +".PARAMETRES ";
		String requeteIns = "insert into "+ baseDossier +".PARAMETRES values ('"+domaine+"', "+MC+","+MBP+",'"+inventaire+"','"+coeff_sais+"')";

		Statement stt = con.createStatement();
		stt.execute(requeteDel);
		stt.execute(requeteIns);

		String[] liste = listeSaison.split(",",0);

		if (coeff_sais.equals("y")) {

			if (liste.length==12)	{
				String requeteDelCoef="delete from "+ baseDossier +".COEF_SAISONS";
				stt.execute(requeteDelCoef);

				String insertCoef;
				for(int mois=1; mois<=12; mois++)	{
					insertCoef="insert into "+ baseDossier +".COEF_SAISONS values ("+mois+","+liste[mois-1]+")";
					stt.execute(insertCoef);
				}

			}
		}			
		
		s.closeConnection(con, null);
		
		return true;	
	}


}
