package org.opensi.compta.actions.transferts;


import java.util.ArrayList;


public class EcrituresOxf {


	ArrayList<EcritureOxf> ecritures = new ArrayList<EcritureOxf>();


	public EcrituresOxf() {}

	
	public void addEcriture(EcritureOxf ecriture) {
	
		ecritures.add(ecriture);
	}
	
	
	public EcritureOxf getEcriture(int index) {
		
		return ecritures.get(index);
	}
	
	
	public int getSize() {
	
		return ecritures.size();
	}
	
	public int getNbOp() {
		
		int nbOp = 0;
	
		for (int i=0; i<ecritures.size(); i++) {
			nbOp += getEcriture(i).getSize();
		}
		
		return nbOp;
	}
	
	public boolean isStable() {
	
		boolean stable = true;
	
		for (int i=0; i<ecritures.size() && stable; i++) {
			stable = stable && getEcriture(i).isStable();
		}
		
		return stable;
	}
	

} // fin EcrituresOxf
