/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/**
 * Ligne d'article
 */

package org.opensi.facturation.actions.editions;


public class LigneArticle {	

	protected String refArticle;
	protected String designation;
	protected String marque;
	protected String famille;
	protected String sousFamille;
	protected double tarif_1_HT;
	protected double tarif_2_HT;
	protected double tarif_3_HT;
	protected double tarif_4_HT;
	protected double tarif_5_HT;
	protected double tarif_1_TTC;
	protected double tarif_2_TTC;
	protected double tarif_3_TTC;
	protected double tarif_4_TTC;
	protected double tarif_5_TTC;
	protected String refFournisseur;
	protected double prixAchat;
	
	public void setRefArticle(String refArticle) { this.refArticle = refArticle; }
	public void setDesignation(String designation) { this.designation = designation; }
	public void setMarque(String marque) { this.marque = marque; }
	public void setFamille(String famille) { this.famille = famille; }
	public void setSousFamille(String sousFamille) { this.sousFamille = sousFamille; }
	public void setTarif1HT(double tarif_1_HT) { this.tarif_1_HT = tarif_1_HT; }
	public void setTarif2HT(double tarif_2_HT) { this.tarif_2_HT = tarif_2_HT; }
	public void setTarif3HT(double tarif_3_HT) { this.tarif_3_HT = tarif_3_HT; }
	public void setTarif4HT(double tarif_4_HT) { this.tarif_4_HT = tarif_4_HT; }
	public void setTarif5HT(double tarif_5_HT) { this.tarif_5_HT = tarif_5_HT; }
	public void setTarif1TTC(double tarif_1_TTC) { this.tarif_1_TTC = tarif_1_TTC; }
	public void setTarif2TTC(double tarif_2_TTC) { this.tarif_2_TTC = tarif_2_TTC; }
	public void setTarif3TTC(double tarif_3_TTC) { this.tarif_3_TTC = tarif_3_TTC; }
	public void setTarif4TTC(double tarif_4_TTC) { this.tarif_4_TTC = tarif_4_TTC; }
	public void setTarif5TTC(double tarif_5_TTC) { this.tarif_5_TTC = tarif_5_TTC; }
	public void setRefFournisseur(String refFournisseur) { this.refFournisseur = refFournisseur; }
	public void setPrixAchat(double prixAchat) { this.prixAchat = prixAchat; }
	
} // fin LigneArticle
