/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

package org.opensi.util;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

public class Md5 {
	
		
  public Md5() {}
	

     /*
      * Encode la chaine pass en paramtre avec l'algorithme MD5
      *
      * @param key : la chaine  encoder
      *
      * @return la valeur (string) hexadcimale sur 32 bits
      */

      public String getMd5(String key) {
        byte[] uniqueKey = key.getBytes();
        byte[] hash = null;
        MessageDigest md = null;
        try {
          md = MessageDigest.getInstance("MD5");
          hash = md.digest(uniqueKey);
        } catch (NoSuchAlgorithmException e) {
          e.printStackTrace();
        }
        
        StringBuffer hashString = new StringBuffer();
        for ( int i = 0; i < hash.length; ++i ) {
        String hex = Integer.toHexString(hash[i]);
        
        if ( hex.length() == 1 ) {
            hashString.append('0');
            hashString.append(hex.charAt(hex.length()-1));
        } else {
            hashString.append(hex.substring(hex.length()-2));
        }
        }
        return hashString.toString();

      }

    /*
     * Test une chaine et une valeur encod (chaine hexadcimale)
     *
     * @param clearTextTestPassword : la chaine non cod  tester
     * @param encodedActualPassword : la valeur hexa MD5 de rfrence
     *
     * @return true si vrifi false sinon
     */
/*    public boolean testPassword(String clearTextTestPassword,
                     String encodedActualPassword)
                     throws NoSuchAlgorithmException
    {
    String encodedTestPassword = MD5Password.getEncodedPassword(
                        clearTextTestPassword);

    return (encodedTestPassword.equals(encodedActualPassword));
    }
*/	
  
} // fin Md5
