/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/
  
/**
 * Nouveau budget: cration d'une ligne
 */

package org.opensi.compta.actions.suiviActivite;

import java.io.*;
import java.sql.*;
import org.experlog.openeas.api.ServletRequest;
import org.experlog.openeas.api.Action;
import org.experlog.openeas.api.Session;


public class nouveauBudget extends Action {
	

	public boolean serverSide() { return true; }

  public boolean service(Session s, ServletRequest r, Object info) throws Exception {

				
		String baseDossier = s.getCookie().get("BaseDossier");
		Connection con = s.getConnection(null);

		String mois_debut=r.getParameter("MD");
		String mois_fin=r.getParameter("MF");
		String an_debut=r.getParameter("AD");
		String an_fin=r.getParameter("AF");
		String mois_debut_ref=r.getParameter("MDref");
		String mois_fin_ref=r.getParameter("MFref");
		String an_debut_ref=r.getParameter("ADref");
		String an_fin_ref=r.getParameter("AFref");


		//L'identifiant suivant
		String reqId="select max(Id_Budget) as id from "+ baseDossier +".BUDGET";

		Statement stt = con.createStatement();
		ResultSet rset = stt.executeQuery(reqId);
		rset.next();
		int identifiant=rset.getInt("id");
		identifiant++;


		r.addParameter("idBudget",""+identifiant);

		String requeteIns="insert into "+ baseDossier +".BUDGET values ("+identifiant+","+mois_debut+","+an_debut+","+mois_fin+","+an_fin;
		requeteIns+=","+mois_debut_ref+","+an_debut_ref+","+mois_fin_ref+","+an_fin_ref+")";
		
		stt.execute(requeteIns);
		
		s.closeConnection(con, null);		
		
		return true;	
	}

}
