/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

package org.opensi.facturation.commerciaux;


public class LigneCommission {
	
	protected double totalCommission = 0;
	protected long dateDebut;
	protected long dateFin;
	protected String refClient = "";
	protected String refArticle = "";
	protected String marque = "";
	protected String famille = "";
	protected String sousFamille = "";
	protected boolean detailCommissionPossible;
	protected String refFacture = "";
	protected char type;
	
	public void setTotalCommission(double totalCommission) { this.totalCommission = totalCommission; }
	public void setDateDebut(long dateDebut) { this.dateDebut = dateDebut; }
	public void setDateFin(long dateFin) { this.dateFin = dateFin; }
	public void setRefClient(String refClient) { this.refClient = refClient; }
	public void setRefArticle(String refArticle) { this.refArticle = refArticle; }
	public void setMarque(String marque) { this.marque = marque; }
	public void setFamille(String famille) { this.famille = famille; }
	public void setSousFamille(String sousFamille) { this.sousFamille = sousFamille; }
	public void setDetailCommissionPossible(boolean detailCommissionPossible) { this.detailCommissionPossible = detailCommissionPossible; }
	public void setRefFacture(String refFacture) { this.refFacture = refFacture; }
	public void setType(char type) { this.type = type; }

}
