/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

package org.opensi.facturation.commerciaux;

import java.util.ArrayList;


public class Regle {
	
	public String typeCommission;
	public String baseCalcul;
	public String marque;
	public String famille;
	public String sousFamille;
	public String article;
	public String modeCalculQte;
	public String baseCalculQte;
	public ArrayList<Tranche> tranches;
	public boolean hasTranches;

	public Regle(String typeCommission, String baseCalcul, String marque, String famille, String sousFamille, String article, String modeCalculQte, String baseCalculQte, ArrayList<Tranche> tranches) {
		this.typeCommission = typeCommission;
		this.baseCalcul = baseCalcul;
		this.marque = marque;
		this.famille = famille;
		this.sousFamille = sousFamille;
		this.article = article;
		this.modeCalculQte = modeCalculQte;
		this.baseCalculQte = baseCalculQte;
		this.tranches = tranches;
		this.hasTranches = !(tranches.size()==1 && tranches.get(0).binf==0 && tranches.get(0).bsup==0);
	}
	
}


