/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/**
 * Donnes ncessaires  l'exportation
 */

package org.opensi.facturation.expedition;


public class LigneExpedition {	

	protected String num_entier;
	protected String nom_liv;
	protected String adresse_liv;
	protected String comp_adresse_liv;
	protected String adresse_3_liv;
	protected String CP_liv;
	protected String ville_liv;
	protected String pays_liv;
	protected String civ_inter_liv;
	protected String nom_inter_liv;
	protected String tel_inter_liv;
	protected String email_inter_liv;
	protected String code_pays_liv;
	protected String code_porte_liv;
	protected String infos_liv;
	protected String compte_client;
	protected char type_expedition;
	protected double poids;
	protected String ref_client;
	protected String ref_commande;
	protected double valeur_declaree;
	protected int nb_colis;
	protected String code_destinataire;
	protected String code_produit;
	protected String instruction;
	protected String comp_instruction;
	protected String zone_utilisateur;
	protected double montant_reglement;
	protected String date_depart_colis;
	protected String nom_expediteur;
	protected String adresse_expediteur;
	protected String comp_adresse_expediteur;
	protected String CP_expediteur;
	protected String ville_expediteur;
	protected String code_pays_expediteur;
	
	
	public String getNumEntier() {
		return num_entier;
	}
	public void setNumEntier(String num_entier) {
		this.num_entier = num_entier;
	}
	public String getNomLiv() {
		return nom_liv;
	}
	public void setNomLiv(String nom_liv) {
		this.nom_liv = nom_liv;
	}
	public String getAdresseLiv() {
		return adresse_liv;
	}
	public void setAdresseLiv(String adresse_liv) {
		this.adresse_liv = adresse_liv;
	}
	public String getCompAdresseLiv() {
		return comp_adresse_liv;
	}
	public void setCompAdresseLiv(String comp_adresse_liv) {
		this.comp_adresse_liv = comp_adresse_liv;
	}
	public String getAdresse3Liv() {
		return adresse_3_liv;
	}
	public void setAdresse3Liv(String adresse_3_liv) {
		this.adresse_3_liv = adresse_3_liv;
	}
	public String getCPLiv() {
		return CP_liv;
	}
	public void setCPLiv(String cp_liv) {
		CP_liv = cp_liv;
	}
	public String getVilleLiv() {
		return ville_liv;
	}
	public void setVilleLiv(String ville_liv) {
		this.ville_liv = ville_liv;
	}
	public String getPaysLiv() {
		return pays_liv;
	}
	public void setPaysLiv(String pays_liv) {
		this.pays_liv = pays_liv;
	}
	public String getCivInterLiv() {
		return civ_inter_liv;
	}
	public void setCivInterLiv(String civ_inter_liv) {
		this.civ_inter_liv = civ_inter_liv;
	}
	public String getNomInterLiv() {
		return nom_inter_liv;
	}
	public void setNomInterLiv(String nom_inter_liv) {
		this.nom_inter_liv = nom_inter_liv;
	}
	public String getTelInterLiv() {
		return tel_inter_liv;
	}
	public void setTelInterLiv(String tel_inter_liv) {
		this.tel_inter_liv = tel_inter_liv;
	}
	public String getEmailInterLiv() {
		return email_inter_liv;
	}
	public void setEmailInterLiv(String email_inter_liv) {
		this.email_inter_liv = email_inter_liv;
	}
	public String getCodePaysLiv() {
		return code_pays_liv;
	}
	public void setCodePaysLiv(String code_pays_liv) {
		this.code_pays_liv = code_pays_liv;
	}
	public String getCodePorte() {
		return code_porte_liv;
	}
	public void setCodePorteLiv(String code_porte_liv) {
		this.code_porte_liv = code_porte_liv;
	}
	public String getInfosLiv() {
		return infos_liv;
	}
	public void setInfosLiv(String infos_liv) {
		this.infos_liv = infos_liv;
	}
	public String getCompteClient() {
		return compte_client;
	}
	public void setCompteClient(String compte_client) {
		this.compte_client = compte_client;
	}
	public char getTypeExpedition() {
		return type_expedition;
	}
	public void setTypeExpedition(char type_expedition) {
		this.type_expedition = type_expedition;
	}
	public double getPoids() {
		return poids;
	}
	public void setPoids(double poids) {
		this.poids = poids;
	}
	public String getRefClient() {
		return ref_client;
	}
	public void setRefClient(String ref_client) {
		this.ref_client = ref_client;
	}
	public String getRefCommande() {
		return ref_client;
	}
	public void setRefCommande(String ref_commande) {
		this.ref_commande = ref_commande;
	}
	public double getValeurDeclaree() {
		return valeur_declaree;
	}
	public void setValeurDeclaree(double valeur_declaree) {
		this.valeur_declaree = valeur_declaree;
	}
	public int getNbColis() {
		return nb_colis;
	}
	public void setNbColis(int nb_colis) {
		this.nb_colis = nb_colis;
	}
	public String getCodeDestinataire() {
		return code_destinataire;
	}
	public void setCodeDestinataire(String code_destinataire) {
		this.code_destinataire = code_destinataire;
	}
	public String getCodeProduit() {
		return code_produit;
	}
	public void setCodeProduit(String code_produit) {
		this.code_produit = code_produit;
	}
	public String getInstruction() {
		return instruction;
	}
	public void setInstruction(String instruction) {
		this.instruction = instruction;
	}
	public String getCompInstruction() {
		return comp_instruction;
	}
	public void setCompInstruction(String comp_instruction) {
		this.comp_instruction = comp_instruction;
	}
	public String getZoneUtilisateur() {
		return zone_utilisateur;
	}
	public void setZoneUtilisateur(String zone_utilisateur) {
		this.zone_utilisateur = zone_utilisateur;
	}
	public double getMontantReglement() {
		return montant_reglement;
	}
	public void setMontantReglement(double montant_reglement) {
		this.montant_reglement = montant_reglement;
	}
	public String getDateDepart_colis() {
		return date_depart_colis;
	}
	public void setDateDepartColis(String date_depart_colis) {
		this.date_depart_colis = date_depart_colis;
	}
	public String getNomExpediteur() {
		return nom_expediteur;
	}
	public void setNomExpediteur(String nom_expediteur) {
		this.nom_expediteur = nom_expediteur;
	}
	public String getAdresseExpediteur() {
		return adresse_expediteur;
	}
	public void setAdresseExpediteur(String adresse_expediteur) {
		this.adresse_expediteur = adresse_expediteur;
	}
	public String getCompAdresseExpediteur() {
		return comp_adresse_expediteur;
	}
	public void setCompAdresseExpediteur(String comp_adresse_expediteur) {
		this.comp_adresse_expediteur = comp_adresse_expediteur;
	}
	public String getCPExpediteur() {
		return CP_expediteur;
	}
	public void setCPExpediteur(String cp_expediteur) {
		CP_expediteur = cp_expediteur;
	}
	public String getVilleExpediteur() {
		return ville_expediteur;
	}
	public void setVilleExpediteur(String ville_expediteur) {
		this.ville_expediteur = ville_expediteur;
	}
	public String getCodePaysExpediteur() {
		return code_pays_expediteur;
	}
	public void setCodePaysExpediteur(String code_pays_expediteur) {
		this.code_pays_expediteur = code_pays_expediteur;
	}

} // fin LigneExpedition