/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

package org.opensi.util;

import java.text.DecimalFormatSymbols;
import java.text.DecimalFormat;

/*

DEPRECATED - DEPRECATED - DEPRECATED - DEPRECATED

UTILISER ORG/OPENSI/UTIL/TOOLS/FORMATTER.JAVA

*/


public class FormatNombre {
	
	
	DecimalFormat numFormat;
	
		
  public FormatNombre(String pattern) {
	
		numFormat = new DecimalFormat(pattern);
		DecimalFormatSymbols dfs = new DecimalFormatSymbols();
		dfs.setDecimalSeparator('.');
		dfs.setGroupingSeparator(' ');
		numFormat.setDecimalFormatSymbols(dfs);
		numFormat.setGroupingSize(3);		
		numFormat.setGroupingUsed(false);	
	}
	
	public FormatNombre(String pattern, boolean grouping) {
		
		numFormat = new DecimalFormat(pattern);
		DecimalFormatSymbols dfs = new DecimalFormatSymbols();
		dfs.setDecimalSeparator('.');
		dfs.setGroupingSeparator(' ');
		numFormat.setDecimalFormatSymbols(dfs);
		numFormat.setGroupingSize(3);
		numFormat.setGroupingUsed(grouping);	
	}

  public String setGrouping() {
    setUseGrouping(true);
    return "True";
  }
  public String unsetGrouping() {
    setUseGrouping(true);
    return "False";
  }
	
	public void setUseGrouping(boolean grouping) {
	
		numFormat.setGroupingUsed(grouping);	
	}
	
	public void setPattern(String pattern) {
	
		numFormat.applyPattern(pattern);
	}
	
	
	/** renvoie le nombre pass en paramtre format */
	
	public String getNombre(String nombre) {
		try {
			return numFormat.format(Double.parseDouble(nombre));
		}
		catch (NumberFormatException nfe) {
			return nombre;
		}		
  }
  
} // fin FormatNombre
