package webmaj;

import java.io.File;
import java.io.FileWriter;
import java.util.StringTokenizer;
import org.opensi.webmanager.utils.ToolsMAJ;
/**
 * Programme principal
 */
public class Main
{

	private static File aEcrire;
	private static FileWriter fichier;
	private static String type="Main";
	
	public static void main(String args[])
	{
		aEcrire=new File("ServeurQuartz.log");//le fichier de log

		if(args.length<1)
		{
			ToolsMAJ.ecrireLog(aEcrire,type,"ERREUR pas assez de args(params bd)");
		}
		else
		{
			String paramsBD=args[0];
			if(paramsBD.charAt(0)=='\"')
			{
				paramsBD=paramsBD.substring(1,paramsBD.length()-1); // on enlve les " au dbut et  la fin
			}

			ToolsMAJ.ecrireLog(aEcrire,type,"les params:"+paramsBD);

			StringTokenizer listeParamsBD=new StringTokenizer(paramsBD,"|");
			if(listeParamsBD.countTokens()<5)
			{
				ToolsMAJ.ecrireLog(aEcrire,type,"ERREUR pas assez de params BD");
			}
			else
			{


				//On a les paramtres initiaux, on peut continuer
				String url_bd=listeParamsBD.nextToken();
				String driver_bd=listeParamsBD.nextToken();
				String login_bd=listeParamsBD.nextToken();
				String mdp_bd=listeParamsBD.nextToken();
				String dossier_root=listeParamsBD.nextToken();
				
				
				int port=2020;

				if(args.length>1)
				{
					port=Integer.parseInt(args[1]);
				}
				
				ServeurQuartz serveur=new ServeurQuartz(url_bd, driver_bd, login_bd, mdp_bd, dossier_root, port);
				serveur.setDaemon(false);
				serveur.start();
				
				
			}
		}


	}
}
